local GetLocale = GetLocale

local message = {
  ["enUS"] = "Sell grey items",
  ["deDE"] = "Verkaufe graue Gegenst\195\164nde",
	['solditem'] = function(link,price)
		if(GetLocale() == "deDE") then
			return link.." verkauft f\195\188r "..zzLib_buildMoneyString(price,true)
		else
			return link.." sold for "..zzLib_buildMoneyString(price,true)
		end
	end,
	['earnedmoney'] = function(earnedMoney)
		if(GetLocale() == "deDE") then
			return zzLib_buildMoneyString(earnedMoney,true).." verdient."
		else
			return "Earned "..zzLib_buildMoneyString(earnedMoney,true).."."
		end
	end,
}
local mod, addon
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
local GetContainerNumSlots = GetContainerNumSlots
local GetContainerItemLink = GetContainerItemLink
local GetContainerItemInfo = GetContainerItemInfo

local function itemInfo(id)
  local i = {}
  local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id)
  if(itemName) then
    i = {
      ['itemId'] = id,
      ['itemName'] = itemName,
      ['itemLink'] = itemLink,
      ['itemRarity'] = itemRarity,
      ['itemLevel'] = itemLevel,
      ['itemMinLevel'] = itemMinLevel,
      ['itemType'] = itemType,
      ['itemSubType'] = itemSubType,
      ['itemStackCount'] = itemStackCount,
      ['itemEquipLoc'] = itemEquipLoc,
      ['itemTexture'] = itemTexture,
      ['itemSellPrice'] = itemSellPrice
    }
  end
  return i
end

local function getItemId(link)
  local id = nil
  if(link) then
    local _, _, itemString = string.find(link, "^|c%x+|H(.+)|h%[.*%]")
    _,id,_ = strsplit(":",itemString)
  end
  return id
end

local function MERCHANT_SHOW()
	local info,i = {},{}
	local a = 0
	local numberOfSlots,link,id
	local earnedMoney = 0
	while(a<=NUM_BAG_SLOTS) do
		numberOfSlots = GetContainerNumSlots(a)
		local b = 1
		while(b<=numberOfSlots) do
			link = GetContainerItemLink(a, b)
			if(link) then
				id = getItemId(link)
				if(id) then
					info = itemInfo(id)
					if(info['itemRarity'] == 0) then
						if(info['itemSellPrice'] > 0) then
							local _, itemCount, _, _, _ = GetContainerItemInfo(a, b)
							addon:Print(message['solditem'](link,info['itemSellPrice']))
							earnedMoney = earnedMoney + info['itemSellPrice'] * itemCount
							UseContainerItem(a, b)
						end
					end
				end
			end
			b = b + 1
		end
		a = a + 1
	end
	if(earnedMoney > 0) then
		addon:Print(message['earnedmoney'](earnedMoney))
	end  
end

local function modFunc()
	addon = zzMiscHelper_Register(
		"sellgrey",
		"MERCHANT_SHOW",
		MERCHANT_SHOW,
  message[GetLocale()] or message["enUS"])
	if(mod) then mod:UnregisterEvent("PLAYER_LOGIN") end
end

if(IsAddOnLoaded("AddonLoader")==1) then
	modFunc()
else
	mod = CreateFrame("Frame")
	mod:RegisterEvent("PLAYER_LOGIN")
	mod:SetScript("OnEvent", modFunc)
end