local addon = LibStub("LibzzAddOnInit"):Init(...)

local mods = {}
local events = {}
local registered = {}

function addon:eventHandler(event,...)
  for k,v in pairs(mods) do
    if(type(events[v][event]) == 'function' and addon.db.profile[v]) then
      events[v][event](...)
    end
  end
end

function addon:ADDON_LOADED()
	if(IsAddOnLoaded("AddonLoader")==1) then
		for k,v in pairs(mods) do
			for s,t in pairs(events[v]) do
				if(addon:IsEventRegistered(s)) then
					addon:UnregisterEvent(s)
				end
				addon:RegisterEvent(s, "eventHandler")
			end
		end
	end
end

function zzMiscHelper_Register(name,event,func,desc)
  mods[#mods + 1] = name
  events[name] = { [event] = func}
  if(not registered[event]) then
    registered[event] = true
    addon:RegisterEvent(event, "eventHandler")
  end
  addon:AddConfigEntry("toggle",name,desc,nil,1)
  return addon
end
